/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef WOOLEXCEPTION_H
#define WOOLEXCEPTION_H


#include "../base/cvs_info.h"
#include <error.h>
#include <errno.h>
#include <string>
#include <stdexcept>
#include <exception>

namespace wool {

/**
 *  Exception interface of wool
 * @author Vukasin Toroman <vtoroman@astaro.de> (C) Astaro AG 2005
 */
class exception
:public std::exception
{
public:
    /**
     *  cvs info
     */
    VERSION_INFO_INLINE("$Id: exception.h,v 1.4 2007/01/11 15:18:21 vtoroman Exp $");
    /**
     *  String definition
     */
    typedef std::string string_type;
    /**
     *  @param s message
     */
    exception( string_type s = "" ) throw ():m_error_message(s) {};

    const char * what () const throw () {
      return m_error_message.c_str();
    }

    static inline string_type c_error ( int error_code = errno ) {
        char error_message [1024];
        return std::string(strerror_r(error_code,error_message,1024));
    }

    virtual ~exception() throw () {};

protected:
    std::string m_error_message;
};

};

#endif
