/***************************************************************************
 *   Copyright (C) 2005 by Vukasin Toroman                                 *
 *   vtoroman@vtoroman05                                                   *
 *                                                                         *
 *  For more licensing information consult COPYING                         *
 ***************************************************************************/
#ifndef WOOLLOGTRAITS_H
#define WOOLLOGTRAITS_H

#include <bitset>
#include <syslog.h>

#include "../base/queue.h"
#include "../base/debug.h"

namespace wool {

/**
@author Vukasin Toroman
*/
class Log
{
  public:
    static void setLogIdentity(const char * i);
    static const char * getLogIdentity( );

    static void setLogMask(const std::bitset<5> & l);
    static const std::bitset<5> & getLogMask( );
	
    //static void logf(int facility, int level, const char * format, ...);
    static void log(int facility, int level, const std::string & msg);
    struct LogUnit {
      std::string message;
      int facility;
      int level;
    };


    class Queue: public wool::Queue<LogUnit>{
    public:
      Queue();
      virtual ~Queue();      

      virtual void handle(UnitPtr u);
      virtual void onError(const std::exception & e, UnitPtr u );
    };
    inline static Log::Queue & GetQueue() { return s_logQueue; }
  private:
    static Log::Queue & s_logQueue;
    static char * s_syslogIdentity;
    static std::bitset<5> s_levelMask;
};
}

#endif
