/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifndef WOOL_UNIXDOMAIN_H
#define WOOL_UNIXDOMAIN_H



#include "../base/wool_stl_includes.h"
#include "../base/debug.h"
#include "../base/cvs_info.h"

#include <sys/un.h>
#include <fcntl.h>
#include <cerrno>
#include <cstdlib>

namespace wool {
  namespace local {
  struct address :public wool::address {
    public:
      typedef std::string path_type;
      
      inline address (const path_type & p) : wool::address(wool::address::local){
        ::memcpy(get_data(),p.c_str(),std::min<unsigned>(p.length()+1,sizeof(sockaddr)-sizeof(sa_family_t))); 
      }
	};
	static const socket::type_record unix_stream = { socket::local, socket::stream_socket, socket::unspec }; 
  };
};

#endif
