#ifndef SWOOL_CERT_H
#define SWOOL_CERT_H

#include "../swool/name.hh"
#include "../swool/key.hh"
#include "../base/wrapper.hh"

namespace wool {
  namespace swool {
    class X509Cert : public wool::Wrapper<X509>{
    public:
      X509Cert( X509 * r = NULL, bool owns = false );
      ~X509Cert();
      
      void setSubject( Name & n );
      const Name & getSubject() const;
      
      void setIssuer( Name & n );
      const Name & getIssuer() const;
      
      void setStartTime( time_t t = -1 );
      void setEndTime( time_t t );
      
      const X509Cert & print ( std::ostream & out ) const;
      
      void sign (Key & pkey);
      void setPublicKey ( Key & pkey );
      const Key & getPublicKey ( ) const;

    protected:
      virtual void update();
      virtual void free( X509 * c);
      virtual X509 *generate();
    private:
      Name * m_subject;
      Name * m_issuer;
      Key * m_publicKey;
      
    };
  };
};

namespace std {
  inline std::ostream & operator << ( std::ostream &  out, const wool::swool::X509Cert & r ) {
    r.print(out);
    return out;
  }
};

#endif
