/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "swool/cipher.h"

namespace wool
{
  namespace swool {

    const cipher::direction_type cipher::encryption = 1;
    const cipher::direction_type cipher::decryption = 0;

    cipher::cipher( cipher::cipher_type ct,
                    cipher::key_type key,
                    cipher::iv_type iv,
                    cipher::int_type enc )
    :bio(bio::f_cipher )
    {
      BIO_set_cipher(get_wrapped(),
                    ct(),
                    (unsigned char*)(const_cast<char*>(key.data())),
                    (unsigned char*)(const_cast<char*>(iv.data())),
                    enc);
    }


    cipher::~cipher(){}


  };
};
