#ifndef SWOOL_REQ_H
#define SWOOL_REQ_H

#include "../base/wrapper.hh"
#include "../swool/name.hh"
#include "../swool/key.hh"

namespace wool {
  namespace swool {
    class X509Req : wool::Wrapper<X509_REQ>{
    public:
      X509Req( X509_REQ * r = NULL, bool owns = false );
      ~X509Req();

      void setSubject( Name & n );
      const Name & getSubject() const;

      X509_REQ * openssl_req();
      const X509_REQ * openssl_req() const;

      const X509Req & print ( std::ostream & out ) const;
    
      void sign (Key & pkey);
      void setPublicKey ( Key & pkey );
      const Key & getPublicKey ( ) const;

    private:
      void update();
      void free( X509_REQ * r );
      X509_REQ * generate();

      Name * m_subject;
      Key * m_publicKey;
      
    };
  }
};

namespace std {
  inline std::ostream & operator << ( std::ostream &  out, const wool::swool::X509Req & r ) {
    r.print(out);
    return out;
  }
};

#endif
