//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <sys/time.h>
#include <sys/resource.h>
#include <iostream>
#include <error.h>
#include <fstream>
#include "../base/stringmap.h"

int main_stl() {
	std::string s;
	std::map<std::string, unsigned long long> smap;
	int lc = 0;
	std::ifstream input, candidates;

	input.open("/tmp/ws.surbl.org.rbldnsd.domains.txt");
	std::cout << "Compile: " << std::endl;
	while(std::getline(input,s)) {
		smap[s] = lc;
		if((lc%1000) == 0)
			std::cout << "\r   " << lc << std::flush;
		lc++;
	}
	std::cout << std::endl;
	
	input.close();

	candidates.open("/tmp/ws.surbl.org.rbldnsd.domains.txt");
	lc=0;
	std::cout << "Lookup: " << std::endl;
	while(std::getline(candidates,s)) {
		lc++;
		unsigned long v = smap[s];
		//std::cout << "resolved " << v << " - " << s << std::endl;
		if((lc%1000) == 0)			std::cout << "\r   " << lc<< std::flush;
	}
	std::cout << std::endl;
  return 0;

}

int main_wool( ) {
	std::string s;
	wool::stringhash smap;
	int lc = 0;
	std::ifstream input, candidates;

	input.open("/tmp/ws.surbl.org.rbldnsd.domains.txt");
	std::cout << "Compile: " << std::endl;
	while(std::getline(input,s)) {
		smap.add_hash(s);
		if((lc%1000) == 0)
			std::cout << "\r   " << lc << std::flush;
		lc++;
	}
	std::cout << std::endl;
	
	input.close();

	candidates.open("/tmp/ws.surbl.org.rbldnsd.domains.txt");
	lc=0;
	std::cout << "Lookup: " << std::endl;
	while(std::getline(candidates,s)) {
		lc++;
		unsigned long v = smap.hash(s);
		//std::cout << "resolved " << v << " - " << s << std::endl;
		if((lc%1000) == 0)			std::cout << "\r   " << lc<< std::flush;
	}
	std::cout << std::endl;
  return 0;
};


int main( int argc, char *argv[] ) {
	return main_wool();
}
