/***************************************************************************
*   Copyright (C) 2005 by Vukasin Toroman                                 *
*   vtoroman@astaro.de                                                    *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Library General Public License as       *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Library General Public     *
*   License along with this program; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <jackal/xmlrpc.h>


class TestClient : public jackal::xmlrpc::Proxy {
public:
  TestClient(const std::string & socket_path, const std::string & object_path ) : Proxy(socket_path, object_path){}
  TestClient ( const std::string & url ) : Proxy (url) {}
  virtual ~TestClient() {}
  
  DECLARE_JACKAL_PROXY0(getTwo, int);
  DECLARE_JACKAL_PROXY2(getProduct, int, int, int);
  DECLARE_JACKAL_PROXY2(append, std::string, std::string, std::string);
};

using namespace std;

int main( int argc, char *argv[] ) {
  TestClient tc("http://127.0.0.1:8080/test");

  /**
   * It would be nice if...
   *
   * TestClient tc("tcp://127.0.0.1:8080", "xmlrpc://localhost/test");
   * TestClient tc("unix:/tmp/test", "xmlrpc://localhost/test");
   **/

  std::cout << "getTwo() = "<<tc.getTwo() << std::endl;
  std::cout << "getProduct(2,4) = "<<tc.getProduct(2,4) << std::endl;
  std::string s1 = "string1hüperdüper";
  std::string s2 = "string2wääd";
  std::cout << "append('"<<s1<<"','"<<s2<<"') = "<<tc.append(s1,s2) << std::endl;
  return EXIT_SUCCESS;
}
