/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <test/test_dlmodule.h>

namespace wool
{
namespace test
{

void test_dlmodule::testEmpty()
{
    CPPUNIT_ASSERT(path() == "");
}

void test_dlmodule::testLoad()
{
    path("libm.so",now);
    dlmodule::symbol_type sym_type = symbol("cos");
    CPPUNIT_ASSERT(sym_type != NULL);
    typedef double (*cosine_handle)(double) ;
    cosine_handle cosine = (cosine_handle)sym_type;
    CPPUNIT_ASSERT(cosine(0.0) == 1.0);
    close();
}

void test_dlmodule::testSymbol_lookup_failure()
{
    path("libm.so",now);
    dlmodule::symbol_type sym_type = symbol("cos");
    CPPUNIT_ASSERT(sym_type != NULL);
    close();
    CPPUNIT_ASSERT_THROW( symbol("cos"), dlmodule::symbol_lookup_failure );
}

void test_dlmodule::testLoad_failure()
{
    close();
    CPPUNIT_ASSERT_THROW( path("a"), dlmodule::load_failure );
}



};
};


