/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifndef TEST_DLMODULE_H
#define TEST_DLMODULE_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "../base/wool_stl_includes.h"
#include "../dl/dlmodule.h"


namespace wool
{
namespace test
{

/**
 * test for dlmodule.
 * @author Manfred Koch <mkoch@astaro.de> (C) Astaro AG 2005
 */
class test_dlmodule : public CppUnit::TestFixture, public wool::dlmodule
{

private:


public:
    inline test_dlmodule()
    {}
    inline ~test_dlmodule() throw ()
    {}

    /**
     *  initialize test
     */
    inline void setUp()
    {
        SAVE_HEADER_INFO(wool::dlmodule);
    }
    /**
     *  shutdown test
     */
    inline void tearDown()
    {}

    /**
     * test empty module wrapper
     */
    void testEmpty();

    /**
     * test to load the symbol "cos" from "libm.so"
     */
    void testLoad();

    /**
     * test symbol_lookup_failure
     */
     void testSymbol_lookup_failure();

    /**
     * test load_failure
     */
    void testLoad_failure();


    /**
     * creates the test suite for the dlmodule
     * @return CppUnit::Test
     */
    inline static CppUnit::Test *suite()
    {
        CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "test_dlmodule" );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_dlmodule>(
                                   "testEmpty",
                                   &test_dlmodule::testEmpty ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_dlmodule>(
                                   "testLoad",
                                   &test_dlmodule::testLoad ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_dlmodule>(
                                   "testLoad_failure",
                                   &test_dlmodule::testLoad_failure ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_dlmodule>(
                                   "testSymbol_lookup_failure",
                                   &test_dlmodule::testSymbol_lookup_failure ) );
        return suiteOfTests;
    }

};
};
};
#endif
