/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifndef WOOL_IP4_TEST_H
#define WOOL_IP4_TEST_H

#include "../socket/inet.h"

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>


namespace wool
{
namespace test
{

/**
 *  test for ip4 and dns class.
 *  @author Manfred Koch <mkoch@astaro.de> (C) Astaro AG 2005
 */
class test_ip4: public CppUnit::TestFixture
{

public:

    inline test_ip4(){}


    inline ~test_ip4(){}

    /**
     *  initialize the test
     */
    inline void setUp()
    {
        //SAVE_HEADER_INFO(wool::inet::ip);
    }
    /**
     *  shutdown the test
     */
    inline void tearDown(){}
    /**
     *  test the different constructors
     */
    void testConstructors();
    /**
    * test the copy constructor with ip4 object as parameter
    */
    void testCopyConstructorIP4();
    /**
    * test the copy constructor with a long as parameter
    */
    void testCopyConstructor_c_ip();
    /**
      *  test lower operator
      */
    void testLowerOperator();
    /**
      * test string operator
      */
      void testStringOperator();
      /**
      * test dns resolve
      */
      void testDNS_resolve();

     /**
      * creates the test suite for the ip4 test
      * @return CppUnit::Test
      */
      inline static CppUnit::Test *suite()
      {
        CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "test_ip4" );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_ip4>(
                                    "testConstructors",
                                    &test_ip4::testConstructors ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_ip4>(
                                    "testCopyConstructorsP4",
                                    &test_ip4::testCopyConstructorIP4 ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_ip4>(
                                    "testCopyConstructor_c_ip",
                                    &test_ip4::testCopyConstructor_c_ip ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_ip4>(
                                    "testLowerOperator",
                                    &test_ip4::testLowerOperator ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_ip4>(
                                    "testStringOperator",
                                    &test_ip4::testStringOperator ) );
        suiteOfTests->addTest( new CppUnit::TestCaller<test_ip4>(
                                    "testDNS_resolve",
                                    &test_ip4::testDNS_resolve ) );
        return suiteOfTests;
      }
};

};
};

#endif



