/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/**************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <test/test_message2822.h>
#include "rfc2822/message_rfc2822.h"

namespace wool {
namespace test {

void test_message2822::testFoldingLength() {
    //wool::header_traits<rfc2822::header> header;
    //CPPUNIT_ASSERT(header.folding_length() == 78);
}

void test_message2822::testMax_line_length() {
    //wool::header_traits<rfc2822::header> header;
    //test is disabled because of flexibility gained by supporting lines of length up to 1048576 bytes
    //CPPUNIT_ASSERT(header.max_line_length() == 1024);
}

void test_message2822::testMaxLenght() {
    //wool::header_traits<rfc2822::header> header;
    //CPPUNIT_ASSERT(header.max_length() == 1048576);
}

void test_message2822::testEOL() {
    //wool::header_traits<rfc2822::header> header;
    //CPPUNIT_ASSERT(header.eol() == '\n');
}

void test_message2822::testWS() {
    //wool::header_traits<rfc2822::header> header;
    //CPPUNIT_ASSERT(header.ws() == ' ');
}

void test_message2822::testSeparator() {
    //wool::header_traits<rfc2822::header> header;
    //CPPUNIT_ASSERT(header.separator() == ':');
}

void test_message2822::testNull() {
    //wool::header_traits<rfc2822::header> header;
    //CPPUNIT_ASSERT(header.null() == 0);
}

void test_message2822::testTerminator() {
    //wool::header_traits<rfc2822::header> header;
    //std::string l;
    //CPPUNIT_ASSERT(header.check_terminator(l));
}

void test_message2822::testParse_RFC_conform_Header() {
    WOOL_DEBUG("testParse_RFC_conform_Header");
    std::string str_header ("Date\t\t :\t27 Aug 76 0932 PDT\r\nFrom\t:\tKen Davis <KDavis@This-Host.This-net> \r\nSubject\t:\tRe: The Syntax in the RFC \r\nSender\t:\tKSecy@Other-Host\r\nReply-To:\tSam.Irving@Reg.Organization \r\nTo\t:\tGeorge Jones <Group@Some-Reg.An-Org>, A1.Neuman@MAD.Publisher \r\nCC\t:\tImportant Folk:\r\n\tTom Softwood <Balsa@Tree.Root>,\r\n\t\"Sam Irving\"@Other-Host;,\r\n\t Standard Distribution:\r\n\t/main/davis/people/standard@Other-Host,\"<Jones>standard.dist.3\"@Tops-20-Host>;\r\nComment\t:\tSam is away on buisness. Hes asked me to handle his mail for him. He'll be able to provide a more accurate explanation when he returns next week.\r\nIn-Reply-To:\t<some.string@DBM.Group>, George's message \r\nX-Special-Action:\tThis is a sample of user-defined fieldnames. There could also be a field-name \"Special-action\", but its name might later be preemted\r\nMessage-ID: <4231.629.XYzi-What@Other-Host>\r\n\r\nName: value\r\n\n");


    rfc2822::header header, header2;
 
    wool::rfc2822::header_loader msg_loader(header), loader2(header2);

    std::string::iterator in_it = msg_loader.parse(str_header.begin(), str_header.end());
    loader2.parse(in_it, str_header.end());
    
    CPPUNIT_ASSERT(header2.size() == 1);	
    CPPUNIT_ASSERT(header.size() == 11);

    rfc2822::header::const_iterator it = header.find("Date");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==0);


    CPPUNIT_ASSERT(it->second == "27 Aug 76 0932 PDT");
    it = header.find("From");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==1);
    CPPUNIT_ASSERT(it->second == "Ken Davis <KDavis@This-Host.This-net>");

    it = header.find("Subject");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==2);
    CPPUNIT_ASSERT(it->second == "Re: The Syntax in the RFC");

    it = header.find("Sender");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==3);
    CPPUNIT_ASSERT(it->second == "KSecy@Other-Host");

    it = header.find("Reply-To");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==4);
    CPPUNIT_ASSERT(it->second == "Sam.Irving@Reg.Organization");

    it = header.find("To");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==5);
    CPPUNIT_ASSERT(it->second == "George Jones <Group@Some-Reg.An-Org>, A1.Neuman@MAD.Publisher");

    it = header.find("CC");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==6);
    CPPUNIT_ASSERT(it->second == "Important Folk: Tom Softwood <Balsa@Tree.Root>, \"Sam Irving\"@Other-Host;, Standard Distribution: /main/davis/people/standard@Other-Host,\"<Jones>standard.dist.3\"@Tops-20-Host>;");

    it = header.find("Comment");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==7);
    CPPUNIT_ASSERT(it->second == "Sam is away on buisness. Hes asked me to handle his mail for him. He'll be able to provide a more accurate explanation when he returns next week.");

    it = header.find("In-Reply-To");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==8);
    CPPUNIT_ASSERT(it->second == "<some.string@DBM.Group>, George's message");

    it = header.find("X-Special-Action");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==9);
    CPPUNIT_ASSERT(it->second == "This is a sample of user-defined fieldnames. There could also be a field-name \"Special-action\", but its name might later be preemted");

    it = header.find("Message-ID");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(std::distance<rfc2822::header::const_iterator>(header.begin(),it)==10);
    CPPUNIT_ASSERT(it->second == "<4231.629.XYzi-What@Other-Host>");

}

void test_message2822::testEmptyFieldName() {
    WOOL_DEBUG("testEmptyFieldName");
    std::string str_header(":asjfokefhl\r\n\r\n");
    rfc2822::header msg;
    wool::rfc2822::header_loader msg_loader(msg);
    msg_loader.parse(str_header.begin(), str_header.end());
    CPPUNIT_ASSERT(msg.size() == 0);
}

void test_message2822::testEmptyFieldBody() {
    WOOL_DEBUG("testEmptyFieldBody");
    std::string str_header("Comment:\r\n\r\n");
    rfc2822::header msg;
    wool::rfc2822::header_loader msg_loader(msg);
    msg_loader.parse(str_header.begin(), str_header.end());
    CPPUNIT_ASSERT(msg.size() == 0);
}

void test_message2822::testLine_length_Overflow() {
    WOOL_DEBUG("testLine_length_Overflow");
    std::string str_header("Comment:");
    // 80 characters
    str_header.append(wool::rfc2822::header_loader::max_entry_length+1,'a');
    str_header.append("\r\n\r\n");

    rfc2822::header msg;
    wool::rfc2822::header_loader msg_loader(msg);
    CPPUNIT_ASSERT_THROW( msg_loader.parse(str_header.begin(), str_header.end()), wool::exception );
}

void test_message2822::testMax_Header_Length() {
    WOOL_DEBUG("testMax_Header_Length");
    std::string str_comment("Comment:");
    // 80 characters
    std::string a("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
    for (int i=0; i < 10 ; ++i)  //808 characters in a line
        str_comment.append(a);

    std::string str_header;
    for (int i=0; i < 1298; ++i) {
        str_header.append(str_comment);
        str_header.append("\r\n");
    }
    str_header.append("\r\n"); // 1051382 characters in header

    rfc2822::header header;
    rfc2822::header_loader loader(header);
    CPPUNIT_ASSERT_THROW( loader.parse(str_header.begin(), str_header.end()), wool::exception );
}

void test_message2822::testCompactWhitespace() {
    WOOL_DEBUG("testCompactWhitespace");
    std::string str_header ("Date:\t  Fri,               \n  \t \n 21    Nov 1997 09:55:06\12 -0600\r\nReceived: from x.y.test\n\tby example.net\n\tvia TCP\n\twith ESMTP\n\tid ABC12345\n\tfor <mary@example.net>\r\n\r\n");

    rfc2822::header header;
    wool::rfc2822::header_loader loader(header);
    loader.parse(str_header.begin(), str_header.end());

    rfc2822::header::const_iterator it = header.find("Date");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "Fri, 21 Nov 1997 09:55:06 -0600");

    it = header.find("Received");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "from x.y.test by example.net via TCP with ESMTP id ABC12345 for <mary@example.net>");
}

void test_message2822::testAddresses() {
    WOOL_DEBUG("testAddresses");
    std::string str_header ("From: \"John Q. Public\" <john.q.public@example.com>\r\nTo: Mary Smith <mary@x.test>, jdoe@example.org, Who? <one@y.test>\r\nCC: <boss@nil.test>, \"Giant; \\\"Big\\\" Box \" <sysservices@example.net>\r\nDate: Tue, 1 Jul 2003 10:52:37 +0200\r\n\r\n\r\n");

    rfc2822::header header;
    wool::rfc2822::header_loader loader(header);
    loader.parse(str_header.begin(), str_header.end());

    rfc2822::header::const_iterator it = header.find("From");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "\"John Q. Public\" <john.q.public@example.com>");

    it = header.find("To");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "Mary Smith <mary@x.test>, jdoe@example.org, Who? <one@y.test>");

    it = header.find("CC");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "<boss@nil.test>, \"Giant; \\\"Big\\\" Box \" <sysservices@example.net>");

    it = header.find("Date");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "Tue, 1 Jul 2003 10:52:37 +0200");
}

void test_message2822::testGroupAddresses() {
    WOOL_DEBUG("testGroupAddresses");
    std::string str_header ("From: Pete <pete@silly.example>\r\nTo: A Group:Chris Jones<c@a.test>,joe@where.test,John <jdoe@one.test>;\r\nCC: Undisclosed recipiennts:;\r\n\r\n");

    rfc2822::header header;
    wool::rfc2822::header_loader loader(header);
    loader.parse(str_header.begin(), str_header.end());

    rfc2822::header::const_iterator it = header.find("From");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "Pete <pete@silly.example>");

    it = header.find("To");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "A Group:Chris Jones<c@a.test>,joe@where.test,John <jdoe@one.test>;");

    it = header.find("CC");
    CPPUNIT_ASSERT(it != header.end());
    CPPUNIT_ASSERT(it->second == "Undisclosed recipiennts:;");
}

void test_message2822::testNonASCIICharacter() {
    WOOL_DEBUG("testNonASCIICharacter");
    std::stringstream ss;
    ss << "Hello";
    for (int i=127; i<255; i++)
        ss << (char)i;
    ss << ":World" << std::endl << std::endl;
    std::string str_header = ss.str();

    rfc2822::header msg;
    ss >> msg;
    rfc2822::header::const_iterator it = msg.begin();
    CPPUNIT_ASSERT(it->first == "Hello");
    CPPUNIT_ASSERT(it->second == "World");

}

};
};



