#include "../thread/rwlock.h"
#include <iostream>


using namespace wool;

RWMutex mutex;

void thread1 ( ) {
  std::cout << "thread 1: wait for read lock " << std::endl;
  RWMutex::ReadLock rl1(mutex);
  std::cout << "thread 1: lock " << std::endl;
}

void thread2 ( ) {
  boost::xtime t;
  boost::xtime_get(&t, boost::TIME_UTC);
  t.sec+=10;
  boost::thread().sleep(t);
  std::cout << "thread 2:wait for write lock " << std::endl;
  RWMutex::WriteLock wl1(mutex, true);
  std::cout << "thread 2:lock " << std::endl;
}

int main ( int argc, char ** argv ) {
  RWMutex::ReadLock rl1(mutex);
  RWMutex::ReadLock rl2(mutex);
  RWMutex::WriteLock wl1(mutex);
  RWMutex::WriteLock wl2(mutex);
  RWMutex::ReadLock rl3(mutex);
  std::string line;
  
  std::cout << "checkpoint 1 " << std::endl;
  boost::thread t1(thread1);
  boost::thread t2(thread2);
  
  std::cout << "press enter to release write locks " << std::endl;
  std::getline(std::cin, line);
  wl1.unlock();
  wl2.unlock();
  std::cout << "unlocked write locks " << std::endl;

  std::cout << "press enter to release read locks " << std::endl;
  std::getline(std::cin, line);
  rl1.unlock();
  rl2.unlock();
  rl3.unlock();
  std::cout << "unlocked read locks " << std::endl;

  t1.join();
  t2.join();
  return 0;
}
