/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifndef TEST_SWOOL_H
#define TEST_SWOOL_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "../base/wool_stl_includes.h"

#include "../swool/ssl_filter.h"
#include "../swool/cipher.h"
#include "../swool/bio.h"

#include <xmlwrapp/xmlwrapp.h>


namespace wool
{
namespace test
{
        /**
        * test for swool.
        * @author Vukasin Toroman <vtoroman@astaro.de> (C) Astaro AG 2005
        */
        class test_swool : public CppUnit::TestFixture
        {
                public:
                        inline test_swool(){}
                        inline ~test_swool() throw () {}
                        /**
                         *  initialize the test
                         */
                        inline void setUp(){}
                        /**
                         *  shutdown the test
                         */
                        inline void tearDown(){}


                        /**
                         *  test Base64 en/decoding
                         */
                        void testBase64 ();

                        /**
                         * creates the test suite for swool
                         * @return CppUnit::Test
                         */
                        inline static CppUnit::Test *suite()
                        {
                                CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "test_swool" );

                                suiteOfTests->addTest( new CppUnit::TestCaller<test_swool>(
                                                "testBase64",
                                &test_swool::testBase64 ) );
                                return suiteOfTests;
                        }

        };
        };
};
#endif
