/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <test/test_tcp_network.h>

namespace wool
{
namespace test
{

void test_tcp_network::testConstructor()
{
  wool::inet::address tcp;
  tcp = "localhost";
  std::string ip = std::string(tcp.get_ip()) ;
  WOOL_DEBUG("IP IS " << ip);
  CPPUNIT_ASSERT(ip == "127.0.0.1");
  CPPUNIT_ASSERT(tcp.get_port() == 0);

  wool::inet::address tcp_port("localhost",80);
  CPPUNIT_ASSERT(std::string(tcp_port.get_ip()) == "127.0.0.1");
  CPPUNIT_ASSERT(tcp_port.get_port() == 80);

  wool::inet::address tcp_timeout("localhost", 80);
  CPPUNIT_ASSERT(std::string(tcp_timeout.get_ip()) == "127.0.0.1");
  CPPUNIT_ASSERT(tcp_timeout.get_port() == 80);

}

void test_tcp_network::testLower_Equal_Operator()
{
  wool::inet::address local("127.0.0.1",80);
  wool::inet::address other("192.168.3.4",80);
  CPPUNIT_ASSERT(local < other);

  other.set_port(20);
  CPPUNIT_ASSERT(other < local);

  wool::inet::address equal("127.0.0.1",80);
  CPPUNIT_ASSERT(local == equal);
}

void test_tcp_network::testCopyConstructor()
{
  wool::inet::address tcp("127.0.0.1",59);
  wool::inet::address tcp_copy(tcp.get_ip(), tcp.get_port());

  CPPUNIT_ASSERT(tcp == tcp_copy);
}

void test_tcp_network::testStringOperator()
{
    wool::inet::address tcp("127.0.0.1",59);
    std::string tcp_string("127.0.0.1:59");
    CPPUNIT_ASSERT(tcp_string.compare((std::string)tcp)==0);
}

void test_tcp_network::testNetworkConstructor()
{
  //TODO
  /*
  wool::ip4 _ip("127.0.0.1");
  wool::ip4 _netmask("255.255.255.0");
  wool::tcp_network4 network_ip(_ip, _netmask);

  CPPUNIT_ASSERT(network_ip.get_ip() == _ip);
  CPPUNIT_ASSERT(network_ip.netmask == _netmask);

  wool::tcp_network4 network_string("192.168.4.5/255.255.255.0");
  CPPUNIT_ASSERT(std::string("192.168.4.5").compare(network_string.get_ip()) == 0);
  CPPUNIT_ASSERT(std::string("255.255.255.0").compare(network_string.netmask) == 0);

  wool::tcp_network4 netmask_empty("192.168.4.5");
  CPPUNIT_ASSERT(std::string("192.168.4.5").compare(netmask_empty.get_ip()) == 0);
  CPPUNIT_ASSERT(std::string("255.255.255.255").compare(netmask_empty.netmask) == 0);
  */
}

void test_tcp_network::testNetworkLowerOperator()
{
  //TODO
  /*
  wool::tcp_network4 network_first("192.168.4.5/255.255.255.0");
  wool::tcp_network4 network_second("192.168.4.5/255.255.255.5");
  wool::tcp_network4 network_third("127.0.0.1/255.255.255.5");
  CPPUNIT_ASSERT(network_first < network_second);
  CPPUNIT_ASSERT(network_third < network_second);
  */
}

void test_tcp_network::testNetworkEqualOperator()
{
//TODO
/*
  wool::tcp_network4 network_first("192.168.4.5/255.255.255.5");
  wool::tcp_network4 network_second("192.168.4.5/255.255.255.5");
  CPPUNIT_ASSERT(network_first == network_second);
*/
}


void test_tcp_network::testNetworkStringOperator()
{
//TODO
/*
  wool::tcp_network4 network("192.168.4.5/255.255.255.5");
  std::string network_string("192.168.4.5/255.255.255.5");
  CPPUNIT_ASSERT(network_string.compare(std::string(network))==0);
*/
}

void test_tcp_network::testNetworkCount()
{
//TODO
/*
  wool::tcp_network4 network("192.168.2.255/255.255.255.0");
  wool::ip4 ip("192.168.2.12");
  CPPUNIT_ASSERT(network.count(ip));
  wool::ip4 ip_not("172.8.43.7");
  CPPUNIT_ASSERT(!network.count(ip_not));
*/
}



};
};
