/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifndef WOOL_TCP_NETWORK_TEST_H
#define WOOL_TCP_NETWORK_TEST_H

#include "../socket/inet.h"

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>


namespace wool
{
namespace test
{

/**
 *  test for tcp_address4 and tcp_network class.
 *  @author Manfred Koch <mkoch@astaro.de> (C) Astaro AG 2005
 */
class test_tcp_network: public CppUnit::TestFixture
{

public:

    inline test_tcp_network(){}


    inline ~test_tcp_network(){}

    /**
     *  initialize the test
     */
    inline void setUp(){}
    /**
     *  shutdown the test
     */
    inline void tearDown(){}
    /**
     *  test tcp_address4 constructor
     */
    void testConstructor();
    /**
     *  test the tcp_address4 lower operator
     */
    void testLower_Equal_Operator();
    /**
     * test the tcp_address4 copy constructor
     */
     void testCopyConstructor();
     /**
      * test the tcp_address4 string operator
      */
     void testStringOperator();
     /**
      *  test tcp_network constructor
      */
     void testNetworkConstructor();
     /**
      *  test tcp_network lower operator
      */
     void testNetworkLowerOperator();
     /**
      * test tcp_network equal operator
      */
     void testNetworkEqualOperator();
     /**
      *  test tcp_network string operator
      */
     void testNetworkStringOperator();
     /**
      * test tcp_network count method
      */
     void testNetworkCount();

    /**
      * creates the test suite for the tcp_network test
      * @return CppUnit::Test
      */
    inline static CppUnit::Test *suite()
    {
      CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "test_tcp_network" );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testConstructor",
                                  &test_tcp_network::testConstructor ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testLower_Equal_Operator",
                                  &test_tcp_network::testLower_Equal_Operator ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testCopyConstructor",
                                  &test_tcp_network::testCopyConstructor ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testStringOperator",
                                  &test_tcp_network::testStringOperator ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testNetworkConstructor",
                                  &test_tcp_network::testNetworkConstructor ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testNetworkLowerOperator",
                                  &test_tcp_network::testNetworkLowerOperator ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testNetworkEqualOperator",
                                  &test_tcp_network::testNetworkEqualOperator ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testNetworkStringOperator",
                                  &test_tcp_network::testNetworkStringOperator ) );
      suiteOfTests->addTest( new CppUnit::TestCaller<test_tcp_network>(
                                  "testNetworkCount",
                                  &test_tcp_network::testNetworkCount ) );

      return suiteOfTests;
    }
};
};
};

#endif

