/**************************************************************************
*  Copyright (C) 2006 by Jens Finkhaeuser <unwesen@users.sourceforge.net> *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifndef TEST_TESTURI_H
#define TEST_TESTURI_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "../rfc3986/uri.h"



namespace wool
{
namespace test
{
/**
 * test for the URI class.
 * @author Jens Finkhaeuser <unwesen@users.sourceforge.net>, Manfred Koch <mkoch@astaro.com>
 */

  class test_uri : public CppUnit::TestFixture
  {

  private:

  public:
      inline test_uri(){}
      inline ~test_uri(){}


      /**
       * initialise the test
       * prints out cvs info of the url class
       */
      inline void setUp()
      {
        SAVE_HEADER_INFO(wool::URI);
      }

      /**
       *  shutdown test
       */
      inline void tearDown(){}

       void testCheckURI();
       void testGenericURI();
       void testHTTPURI();
       void testURIDefaultScheme();

      /**
       * creates the test suite for the url test
       * @return CppUnit::Test
       */
      inline static CppUnit::Test *suite()
      {
          CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "test_uri" );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_uri>(
                                    "testCheckURI",
                                    &test_uri::testCheckURI ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_uri>(
                                    "testGenericURI",
                                    &test_uri::testGenericURI ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_uri>(
                                    "testHTTPURI",
                                    &test_uri::testHTTPURI ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_uri>(
                                    "testURIDefaultScheme",
                                    &test_uri::testURIDefaultScheme ) );
          return suiteOfTests;
      }

  };
  };
};
#endif
