/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <test/test_url.h>

namespace wool
{
namespace test
{

void test_url::testGoogleSearch()
{
  wool::url url("http://www.google.de/search?hl=de&q=Astaro&btnG=Google-Suche&meta=lr%3Dlang_en");
  CPPUNIT_ASSERT(url.protocol == "http");
  CPPUNIT_ASSERT(url.host == "www.google.de");
  CPPUNIT_ASSERT(*url.path.begin() == "search");
  CPPUNIT_ASSERT(url.query == "hl=de&q=Astaro&btnG=Google-Suche&meta=lr%3Dlang_en");
}

void test_url::testHTTPS()
{
  wool::url url("https://www.amazon.com");
  CPPUNIT_ASSERT(url.protocol == "https");
  CPPUNIT_ASSERT(url.host == "www.amazon.com");
  CPPUNIT_ASSERT(url.path.begin() == url.path.end());
  CPPUNIT_ASSERT(url.query == "");
}

void test_url::testWEB_DE()
{
  wool::url url("http://suche.web.de/search/dir/");
  CPPUNIT_ASSERT(url.protocol == "http");
  CPPUNIT_ASSERT(url.host == "suche.web.de");
  int count = 0;
  for(wool::url::path_type::const_iterator i=url.path.begin();i!=url.path.end();++i)
  {
    if (count == 0)
      CPPUNIT_ASSERT(*i == "search");
    if (count == 1)
      CPPUNIT_ASSERT(*i == "dir");
    if (count == 2)
      CPPUNIT_ASSERT(*i == "");
    ++count;
  }
}



};
};

