/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#ifndef TEST_TESTURL_H
#define TEST_TESTURL_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "../base/wool_stl_includes.h"
#include "../rfc3986/url.h"



namespace wool
{
namespace test
{
/**
 * test for the url struct.
 * @author Manfred Koch <mkoch@astaro.de> (C) Astaro AG 2005
 */

  class test_url : public CppUnit::TestFixture
  {

  private:

  public:
      inline test_url(){}
      inline ~test_url(){}


      /**
       * initialise the test
       * prints out cvs info of the url class
       */
      inline void setUp()
      {
        SAVE_HEADER_INFO(wool::url);
      }

      /**
       *  shutdown test
       */
      inline void tearDown(){}

      /**
       * test if a new tempfile is empty
       */
       void testGoogleSearch();
       /**
        * test https protocol with empty path and query
        */
       void testHTTPS();
       /**
        * test url with more than one subdirectory
        */
       void testWEB_DE();
      /**
       * creates the test suite for the url test
       * @return CppUnit::Test
       */
      inline static CppUnit::Test *suite()
      {
          CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "test_url" );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_url>(
                                    "testGoogleSearch",
                                    &test_url::testGoogleSearch ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_url>(
                                    "testHTTPS",
                                    &test_url::testHTTPS ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_url>(
                                    "testWEB_DE",
                                    &test_url::testWEB_DE ) );
          return suiteOfTests;
      }

  };
  };
};
#endif
