/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef WOOL_TESTTEST_USERNAME_H
#define WOOL_TESTTEST_USERNAME_H

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "../base/wool_stl_includes.h"
#include "../rfc2822/username.h"

namespace wool {

namespace test {

/**
 *  This is the test for the user-class.
 *  @author Manfred Koch <mkoch@astaro.com> (C) Astaro AG 2005
 *  @version $Id: test_username.h,v 1.5 2007/01/11 15:18:44 vtoroman Exp $
 */
class test_username: public CppUnit::TestFixture{
public:
    inline test_username(){}

    inline ~test_username(){}

      /**
       * initialise the test
       * prints out cvs info of the url class
       */
      inline void setUp()
      {
        SAVE_HEADER_INFO(wool::user);
      }

      /**
       *  shutdown test
       */
      inline void tearDown(){}
      /**
       *  test the different constructors
       */
      void testConstructor();
      /**
       *  test the string operator
       */
       void testString();
       /**
        * test the equal operator
        */
       void testEqual();
       /**
        * test the lower operator
        */
        void testLower();
        /**
         *  test the count method
         */
         void testCount();


      /**
       * creates the test suite for the user test
       * @return CppUnit::Test
       */
      inline static CppUnit::Test *suite()
      {
          CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "test_username" );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_username>(
                                    "testConstructor",
                                    &test_username::testConstructor ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_username>(
                                    "testString",
                                    &test_username::testString ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_username>(
                                    "testEqual",
                                    &test_username::testEqual ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_username>(
                                    "testLower",
                                    &test_username::testLower ) );
          suiteOfTests->addTest( new CppUnit::TestCaller<test_username>(
                                    "testCount",
                                    &test_username::testCount ) );

          return suiteOfTests;
      }
};

};

};

#endif
