/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/


#include <cppunit/extensions/HelperMacros.h>
#include "../base/cvs_info.h"
#include "test_unsorted_multimap.h"
#include "test_tmpfile.h"
#include "test_swappable_data.h"
#include "test_dlmodule.h"
#include "test_message2822.h"
#include "test_swool.h"
#include "test_regexp.h"
#include "test_url.h"
#include "test_uri.h"
#include "test_content_type.h"
#include "test_ip4.h"
#include "test_tcp_network.h"
#include "test_username.h"

/*
#undef QT_CPPUNIT_RUNNER

#ifdef QT_CPPUNIT_RUNNER
#include <qapplication.h"
#include <cppunit/ui/qt/TestRunner.h"
typedef CppUnit::QtUi::TestRunner TestRunnerType;
#define INIT_APPLICATION QApplication app(argc,argv);
#else
*/
#include <cppunit/ui/text/TestRunner.h>
typedef CppUnit::TextUi::TestRunner TestRunnerType;
#define INIT_APPLICATION
//#endif


void dummy_sighandler ( int sig ) {
  WOOL_DEBUG("signal: "<<sig);
}
int main(int argc, char *argv[])
{
  INIT_APPLICATION
  ::signal(SIGPIPE,dummy_sighandler);
  TestRunnerType runner;

  runner.addTest( wool::test::test_message2822::suite() );
  runner.addTest( wool::test::test_unsorted_multimap::suite() );
  runner.addTest( wool::test::test_tmpfile::suite() );
  runner.addTest( wool::test::test_swappable_data::suite() );
  runner.addTest( wool::test::test_dlmodule::suite() );
  runner.addTest( wool::test::test_regexp::suite() );
  runner.addTest( wool::test::test_url::suite() );
  runner.addTest( wool::test::test_content_type::suite() );
  runner.addTest( wool::test::test_ip4::suite() );
  runner.addTest( wool::test::test_tcp_network::suite() );
  runner.addTest( wool::test::test_username::suite() );
  runner.addTest( wool::test::test_swool::suite() );
  runner.addTest( wool::test::test_uri::suite() );
  runner.run();
  wool::cvs_info::save_info();
  return 0;
}





