/**************************************************************************
*   Copyright (C) 2004 by Vukasin Toroman                                 *
*   vukasin@toroman.org                                                   *
**************************************************************************/
/************************************************************************** 
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef WOOLTIMER_H
#define WOOLTIMER_H
#include "../thread/thread.h"
namespace wool {
   class timer : public thread{
      public:
         timer ( long ms = 1000l );
         virtual ~timer ( );

         void trigger();
         void set_timeout ( long ms );
         long get_timeout ( ) const;

      protected:
         virtual void on_trigger () = 0;
         virtual void run();
         virtual void on_start();
         virtual void on_finish();
         virtual void on_error( const std::exception & e );

      private:
         long m_timeout;
         bool m_triggered;
         boost::condition m_trigger;
         mutable boost::mutex m_trigger_guard;
   };
}
#endif
